import java.io.IOException;
import java.io.*;
import edu.uiuc.dsi.mutex.*;
import edu.uiuc.dsi.apps.*;

public class Program
{
	public static void main(String[] args)
	{
		// 1. Sanity check on command line parameters...
		if (args.length < 1)
		{
			System.out.println("java Program <0-indexed process ID>");
			return;
		}
		
		// 2. Create the protocol object
		MyProtocol objMyProtocol = null;
		
		try
		{
			// 3. Read in the input of the connections...
			BufferedReader objFileReader = new BufferedReader(new FileReader("settings.txt"));
			String sLine;
			int iCurrentProcessSettings = 0;
			
			while ((sLine = objFileReader.readLine()) != null)
			{
				if (sLine.isEmpty())
					iCurrentProcessSettings++;
				else if (iCurrentProcessSettings == Integer.parseInt(args[0]))
				{
					if (sLine.contains(":"))
						objMyProtocol.connect(sLine.split(":")[0], Integer.parseInt(sLine.split(":")[1]));
					else
						objMyProtocol = new MyProtocol(Integer.parseInt(sLine.substring(0, sLine.indexOf(" "))), sLine.substring(sLine.indexOf(" ") + 1));
				}
			}
			
			objFileReader.close();

			// 4. Set up the distributed object
			DistributedObject objDistributedObject = new DistributedObject("MyObject", new Lamport("MyObject-MutEx"));
			objMyProtocol.addComponent(objDistributedObject);

			// 5. Run protocol-specific methods  
			objMyProtocol.setDistributedObjectClass(objDistributedObject);
			
			// 6. Ready this thread to start the protocol 
			BufferedReader objReader = new BufferedReader(new InputStreamReader(System.in));
			while (!(sLine = objReader.readLine()).contains("exit"))
			{
				if (sLine.contains("start"))
				{
					objDistributedObject.setObject(new MyToken());
					objMyProtocol.broadcast(("start").getBytes());
				}
			}
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}
}
